public class ExceptionsExample{
    
    // this method should return the index 
    // of the target in the array
    // -1 if it is not part of the array
    public static int find(String[] a, String target){
        for ( int i = 0 ; i< a.length; i++ ){
            // 1. try calling the equals method
             try {
                 boolean test = a[i].equals(target);
                 if ( test ){
                     return i;   
                 }
             } catch (Exception e ){
             // 2. if an error happens, continue here
                 System.out.println("Whoops, your array has a null value");
             }
             // 3. continue here in any other case
        }
        return -1;
    }
    
    public static int find2(String[] a, String target) throws Exception{
        for ( int i = 0 ; i< a.length; i++ ){
            boolean test = a[i].equals(target);
            if ( test ){
                return i;   
            }
        }
        return -1;
    }
    
    public static void main(String[] args)  {
        int[] a = new int[ 5 ];
        
       // a[ 6 ] = 10;
        
        Node[] nodeArray = new Node[5];
        //String s = nodeArray[2].toString();
        
        String s = "154ewtwet";
        // 1. try to execute the code
        try {
            int n = Integer.parseInt(s); // this throws an exception
            System.out.println(n);
        } catch ( Exception e ) {
            //2. continue here, if there wass an error
            System.out.println("Hey, please give me a number");
            System.out.println(e);
        }
        // 3. continue here after either executing the code,
        // or catching an error
        System.out.println("The program ended.");
         
        String[] test_array = {"a", null, "aaa"};
        System.out.println(find(test_array, "b"));
        
        try{
           System.out.println(find2(test_array, "b"));
        } catch (Exception e){
           System.out.println("find2 threw an exception");
        }
        
    }
}